import { Reader, Writer } from 'ion-js';
export declare function makeHashReader(reader: Reader, hashFunctionProvider: HasherProvider): HashReader;
export declare function makeHashWriter(writer: Writer, hashFunctionProvider: HasherProvider): HashWriter;
export interface HashReader extends Reader {
    digest(): Uint8Array;
}
export interface HashWriter extends Writer {
    digest(): Uint8Array;
}
export interface HasherProvider {
    (): Hasher;
}
export interface Hasher {
    update(bytes: Uint8Array): void;
    digest(): Uint8Array;
}
export declare function cryptoHasherProvider(algorithm: string): HasherProvider;
export declare function digest(value: any, algorithm: string): Uint8Array;
