"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.digest = exports.cryptoHasherProvider = exports.makeHashWriter = exports.makeHashReader = void 0;
var ion_js_1 = require("ion-js");
var IonHashImpl_1 = require("./internal/IonHashImpl");
function makeHashReader(reader, hashFunctionProvider) {
    return new IonHashImpl_1._HashReaderImpl(reader, hashFunctionProvider);
}
exports.makeHashReader = makeHashReader;
function makeHashWriter(writer, hashFunctionProvider) {
    return new IonHashImpl_1._HashWriterImpl(writer, hashFunctionProvider);
}
exports.makeHashWriter = makeHashWriter;
function cryptoHasherProvider(algorithm) {
    return function () { return new IonHashImpl_1._CryptoHasher(algorithm); };
}
exports.cryptoHasherProvider = cryptoHasherProvider;
function digest(value, algorithm) {
    var writer = (0, ion_js_1.makeBinaryWriter)();
    var hashProvider = cryptoHasherProvider(algorithm);
    var hashWriter = makeHashWriter(writer, hashProvider);
    ion_js_1.dom.Value.from(value).writeTo(hashWriter);
    hashWriter.close();
    writer.close();
    return hashWriter.digest();
}
exports.digest = digest;
//# sourceMappingURL=IonHash.js.map