"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var ion_js_1 = require("ion-js");
var registerSuite = intern.getPlugin('interface.object').registerSuite;
var assert = intern.getPlugin('chai').assert;
var IonHash_1 = require("../src/IonHash");
registerSuite('digest', {
    true: function () { return assert.deepEqual((0, IonHash_1.digest)(true, 'md5'), Uint8Array.from([0xa7, 0x51, 0x0a, 0x8e, 0x9a, 0x56, 0xd0, 0x23,
        0x29, 0x27, 0x2e, 0xb4, 0x96, 0x66, 0xde, 0x12])); },
    allTypes: function () { return assert.deepEqual((0, IonHash_1.digest)([
        null,
        true,
        1,
        -1,
        (0, ion_js_1.load)('1e0'),
        ion_js_1.Decimal.parse('1d0'),
        ion_js_1.Timestamp.parse('2017-01-01T00:00:00-00:00'),
        (0, ion_js_1.load)('hello'),
        "hello",
        (0, ion_js_1.load)('{{"hello"}}'),
        (0, ion_js_1.load)('{{aGVsbG8=}}'),
        [1, 2, 3],
        (0, ion_js_1.load)('(1 2 3)'),
        { c: 3, a: 1, b: 2 },
        (0, ion_js_1.load)('hello::null')
    ], 'md5'), Uint8Array.from([0xb0, 0xd9, 0x03, 0x45, 0xdb, 0x55, 0x79, 0xf1,
        0xd8, 0x2f, 0x12, 0xae, 0x92, 0xc3, 0x23, 0xb5])); },
    unknownAlgorithm: function () { return assert.throws(function () { return (0, IonHash_1.digest)(5, 'unknownAlgorithm'); }); },
});
//# sourceMappingURL=DigestTest.js.map