"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var registerSuite = intern.getPlugin('interface.object').registerSuite;
var assert = intern.getPlugin('chai').assert;
var IonHashImpl_1 = require("../src/internal/IonHashImpl");
registerSuite('_escape', {
    empty: function () { test([], []); },
    noop: function () { test([0x10, 0x11, 0x12, 0x13], [0x10, 0x11, 0x12, 0x13]); },
    escape_b: function () { test([0x0b], [0x0c, 0x0b]); },
    escape_e: function () { test([0x0e], [0x0c, 0x0e]); },
    escape_c: function () { test([0x0c], [0x0c, 0x0c]); },
    escape_bec: function () { test([0x0b, 0x0e, 0x0c], [0x0c, 0x0b, 0x0c, 0x0e, 0x0c, 0x0c]); },
    escape_cc: function () { test([0x0c, 0x0c], [0x0c, 0x0c, 0x0c, 0x0c]); },
    escape_multiple: function () { test([0x0c, 0x10, 0x0c, 0x11, 0x0c, 0x12, 0x0c], [0x0c, 0x0c, 0x10, 0x0c, 0x0c, 0x11, 0x0c, 0x0c, 0x12, 0x0c, 0x0c]); },
});
var test = function (actual, expected) {
    assert.deepEqual((0, IonHashImpl_1._escape)(new Uint8Array(actual)), new Uint8Array(expected));
};
//# sourceMappingURL=EscapeTest.js.map