"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var registerSuite = intern.getPlugin('interface.object').registerSuite;
var assert = intern.getPlugin('chai').assert;
var IonHashImpl_1 = require("../src/internal/IonHashImpl");
registerSuite('_Uint8ArrayComparator', {
    equals: function () { test([0x01, 0x02, 0x03], [0x01, 0x02, 0x03], 0); },
    lessThan: function () { test([0x01, 0x02, 0x03], [0x01, 0x02, 0x04], -1); },
    lessThanDueToLength: function () { test([0x01, 0x02, 0x03], [0x01, 0x02, 0x03, 0x04], -1); },
    greaterThan: function () { test([0x01, 0x02, 0x04], [0x01, 0x02, 0x03], 1); },
    greaterThanDueToLength: function () { test([0x01, 0x02, 0x03, 0x04], [0x01, 0x02, 0x03], 1); },
    unsignedBehavior: function () {
        test([0x01], [0x7f], -1);
        test([0x01], [0x80], -1);
        test([0x01], [0xff], -1);
        test([0x7f], [0x01], 1);
        test([0x80], [0x01], 1);
        test([0xff], [0x01], 1);
    },
});
var test = function (a, b, expected) {
    assert.equal((0, IonHashImpl_1._Uint8ArrayComparator)(new Uint8Array(a), new Uint8Array(b)), expected);
};
//# sourceMappingURL=Uint8ArrayComparatorTest.js.map